/**************************************************************************************
 http://code.google.com/a/apache-extras.org/p/camel-extra

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.


 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 02110-1301, USA.

 http://www.gnu.org/licenses/gpl-2.0-standalone.html
 ***************************************************************************************/
package org.apacheextras.camel.component.exist;

import org.apache.camel.Exchange;
import org.apache.camel.impl.PollingConsumerSupport;
import org.xmldb.api.base.Resource;
import org.xmldb.api.base.ResourceIterator;
import org.xmldb.api.base.XMLDBException;

public class ExistPollingConsumer extends PollingConsumerSupport {
    private ExistEndpoint endpoint;
    private ResourceIterator iterator;

    public ExistPollingConsumer(ExistEndpoint endpoint) {
        super(endpoint);
        this.endpoint = endpoint;
    }

    public Exchange receive() {
        try {
            if (iterator == null) {
                iterator = endpoint.createResourceIterator();
            }
            if (iterator.hasMoreResources()) {
                Resource resource = iterator.nextResource();
                return endpoint.createExchange(resource);
            } else {
                iterator = null;
                return null;
            }
        }
        catch (XMLDBException e) {
            throw new RuntimeExistException(endpoint, e);
        }
    }

    public Exchange receiveNoWait() {
        return receive();
    }

    public Exchange receive(long l) {
        return receive();
    }

    protected void doStart() throws Exception {
    }

    protected void doStop() throws Exception {
    }
}
